package com.jsowell.api.thirdparty;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.jsowell.common.annotation.Anonymous;
import com.jsowell.common.core.controller.BaseController;
import com.jsowell.common.enums.thirdparty.ThirdPlatformTypeEnum;
import com.jsowell.common.enums.ykc.ReturnCodeEnum;
import com.jsowell.common.exception.BusinessException;
import com.jsowell.common.response.RestApiResponse;
import com.jsowell.common.util.JWTUtils;
import com.jsowell.common.util.StringUtils;
import com.jsowell.pile.dto.*;
import com.jsowell.thirdparty.lianlian.common.CommonResult;
import com.jsowell.pile.thirdparty.CommonParamsDTO;
import com.jsowell.thirdparty.platform.util.Cryptos;
import com.jsowell.thirdparty.platform.util.Encodes;
import com.jsowell.thirdparty.xindiantu.service.XDTService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import java.util.Map;

/**
 * 新电途平台 Controller
 *
 * @author Lemon
 * @Date 2024/1/3 13:41:46
 */
@Anonymous
@RestController
@RequestMapping("/xindiantu")
public class XDTController extends BaseController {

    @Autowired
    private XDTService xdtService;

    /**
     * 获取token接口
     * http://localhost:8080/xindiantu/v1/query_token
     */
    @PostMapping("/v1/query_token")
    public CommonResult<?> queryToken(@RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台请求令牌 params:{}", JSON.toJSONString(dto));
        try {
            Map<String, String> map = xdtService.generateToken(dto);
            logger.info("新电途平台请求令牌 result:{}", JSON.toJSONString(map));
            return CommonResult.success(0, "请求令牌成功！", map.get("Data"), map.get("Sig"));
        } catch (UnsupportedEncodingException e) {
            logger.error("获取token接口 异常");
            return CommonResult.failed("获取token发生异常");
        }
    }

    /**
     * 推送充电站信息 notification_stationInfo
     * http://localhost:8080/xindiantu/v1/pushStationInfo
     * @param dto
     * @return
     */
    @PostMapping("/pushStationInfo")
    public RestApiResponse<?> pushStationInfo(@RequestBody PushStationInfoDTO dto) {
        logger.info("推送新电途平台充电站信息 params:{}", JSON.toJSONString(dto));
        RestApiResponse<?> response = null;
        try {
            if (StringUtils.isBlank(String.valueOf(dto.getStationId()))) {
                throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
            }
            xdtService.pushStationInfo(dto);
            response = new RestApiResponse<>();
        }catch (BusinessException e) {
            logger.error("推送新电途平台充电站信息 error",e);
            response = new RestApiResponse<>(e.getCode(), e.getMessage());
        }catch (Exception e) {
            logger.error("推送新电途平台充电站信息 error", e);
            response = new RestApiResponse<>(e);
        }
        logger.info("推送新电途平台充电站信息 result:{}", response);
        return response;
    }

    /**
     * 查询充电站信息
     * @param dto
     */
    @RequestMapping("/v1/query_stations_info")
    public CommonResult<?> query_stations_info(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台查询充电站信息 params:{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");
            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryStationInfoDTO queryStationInfoDTO = JSONObject.parseObject(dataStr, QueryStationInfoDTO.class);
            queryStationInfoDTO.setOperatorId(dto.getOperatorID());
            Map<String, String> map = xdtService.queryStationsInfo(queryStationInfoDTO);
            return CommonResult.success(0, "查询充电站信息成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.error("新电途平台查询充电站信息 error", e);
        }
        return CommonResult.failed("查询充电站信息异常");
    }

    /**
     * 新电途平台查询统计信息
     * http://localhost:8080/xindiantu/v1/query_stations_stats
     * @param dto
     * @return
     */
    @PostMapping("/v1/query_station_status")
    public CommonResult<?> queryStationStatus(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台查询统计信息 params:{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");

            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryStationInfoDTO queryStationInfoDTO = JSONObject.parseObject(dataStr, QueryStationInfoDTO.class);
            queryStationInfoDTO.setOperatorId(dto.getOperatorID());
            Map<String, String> map = xdtService.queryStationStatus(queryStationInfoDTO);
            logger.info("新电途平台查询统计信息 result:{}", JSON.toJSONString(map));
            return CommonResult.success(0, "查询统计信息成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.info("新电途平台查询统计信息 error:", e);
            e.printStackTrace();
        }
        return CommonResult.failed("查询统计信息发生异常");
    }

    /**
     * 新电途平台查询业务策略信息结果
     * http://localhost:8080/xindiantu/v1/query_equip_business_policy
     * @param dto
     * @return
     */
    @PostMapping("/v1/query_equip_business_policy")
    public CommonResult<?> queryEquipBusinessPolicy(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台查询业务策略信息 params:{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");

            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryStartChargeDTO queryStartChargeDTO = JSONObject.parseObject(dataStr, QueryStartChargeDTO.class);
            queryStartChargeDTO.setOperatorId(dto.getOperatorID());
            Map<String, String> map = xdtService.queryEquipBusinessPolicy(queryStartChargeDTO);
            logger.info("新电途平台查询业务策略信息 result:{}", JSON.toJSONString(map));

            return CommonResult.success(0, "查询业务策略信息成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.info("新电途平台查询业务策略信息 error:", e);
            e.printStackTrace();
        }
        return CommonResult.failed("查询业务策略信息发生异常");
    }

    /**
     * 请求设备认证
     * @param request
     * @param dto
     * @return
     */
    @PostMapping("/v1/query_equip_auth")
    public CommonResult<?> query_equip_auth(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台请求设备认证 param:{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");
            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryEquipmentDTO queryEquipmentDTO = JSONObject.parseObject(dataStr, QueryEquipmentDTO.class);
            queryEquipmentDTO.setOperatorID(dto.getOperatorID());
            Map<String, String> map = xdtService.queryEquipAuth(queryEquipmentDTO);
            logger.info("新电途平台请求设备认证 result:{}", JSON.toJSONString(map));
            return CommonResult.success(0, "请求设备认证成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.info("新电途平台请求设备认证 error:", e);
            e.printStackTrace();
        }
        return CommonResult.failed("请求设备认证发生异常");
    }

    /**
     * 请求启动充电
     * @param request
     * @param dto
     * @return
     */
    @PostMapping("/v1/query_start_charge")
    public CommonResult<?> query_start_charge(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台请求启动充电 params :{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");
            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryStartChargeDTO queryStartChargeDTO = JSONObject.parseObject(dataStr, QueryStartChargeDTO.class);
            queryStartChargeDTO.setOperatorId(dto.getOperatorID());
            Map<String, String> map = xdtService.queryStartCharge(queryStartChargeDTO);
            logger.info("新电途平台请求启动充电 result:{}", JSON.toJSONString(map));
            return CommonResult.success(0, "请求启动充电成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.error("新电途平台请求启动充电 error", e);
        }
        return CommonResult.failed("请求启动充电发生异常");
    }

    /**
     * 查询充电状态
     * http://localhost:8080/xindiantu/query_equip_charge_status/{startChargeSeq}
     * @param dto
     * @return
     */
    @PostMapping("/v1/query_equip_charge_status")
    public CommonResult<?> query_equip_charge_status(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台查询充电状态 params :{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");
            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryEquipChargeStatusDTO queryEquipChargeStatusDTO = JSONObject.parseObject(dataStr, QueryEquipChargeStatusDTO.class);
            queryEquipChargeStatusDTO.setOperatorID(dto.getOperatorID());
            Map<String, String> map = xdtService.queryEquipChargeStatus(queryEquipChargeStatusDTO);
            logger.info("新电途平台查询充电状态 result:{}", JSON.toJSONString(map));
            return CommonResult.success(0, "查询充电状态成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.error("新电途平台查询充电状态 error", e);
        }
        return CommonResult.failed("新电途平台查询充电状态发生异常");
    }

    /**
     * 请求停止充电
     * @param request
     * @param dto
     * @return
     */
    @PostMapping("/v1/query_stop_charge")
    public CommonResult<?> query_stop_charge(HttpServletRequest request, @RequestBody CommonParamsDTO dto) {
        logger.info("新电途平台请求停止充电 params :{}", JSON.toJSONString(dto));
        try {
            // 校验令牌
            String token = request.getHeader("Authorization");
            if (!JWTUtils.checkThirdPartyToken(token)) {
                // 校验失败
                return CommonResult.failed("令牌校验错误");
            }
            // 校验签名
            Map<String, String> resultMap = xdtService.checkoutSign(dto);
            if (resultMap == null) {
                // 签名错误
                return CommonResult.failed("签名校验错误");
            }
            String operatorSecret = resultMap.get("OperatorSecret");
            String dataString = resultMap.get("Data");
            String dataSecret = resultMap.get("DataSecret");
            String dataSecretIV = resultMap.get("DataSecretIV");
            // 解密data
            byte[] plainText = Cryptos.aesDecrypt(Encodes.decodeBase64(dataString), dataSecret.getBytes(), dataSecretIV.getBytes());
            String dataStr = new String(plainText, StandardCharsets.UTF_8);
            // 转换成相应对象
            QueryStartChargeDTO queryStartChargeDTO = JSONObject.parseObject(dataStr, QueryStartChargeDTO.class);
            queryStartChargeDTO.setOperatorId(dto.getOperatorID());
            Map<String, String> map = xdtService.queryStopCharge(queryStartChargeDTO);
            logger.info("新电途平台请求停止充电 result:{}", JSON.toJSONString(map));
            return CommonResult.success(0, "请求停止充电成功！", map.get("Data"), map.get("Sig"));
        } catch (Exception e) {
            logger.error("新电途平台请求停止充电 error", e);
        }
        return CommonResult.failed("新电途平台请求停止充电发生异常");
    }

    /**
     * 新电途推送停止充电结果
     * http://localhost:8080/xindiantu/pushStartChargeResult
     * @param orderCode
     * @return
     */
    @GetMapping("/pushStopChargeResult/{orderCode}")
    public RestApiResponse<?> pushStopChargeResult(@PathVariable("orderCode") String orderCode) {
        logger.info("新电途平台推送停止充电结果 params:{}", orderCode);
        RestApiResponse<?> response = null;
        try {
            String result = xdtService.notificationStopChargeResult(orderCode);
            response = new RestApiResponse<>(result);
        }catch (BusinessException e) {
            logger.error("新电途平台推送停止充电结果 error",e);
            response = new RestApiResponse<>(e.getCode(), e.getMessage());
        }catch (Exception e) {
            logger.error("新电途平台推送停止充电结果 error", e);
            response = new RestApiResponse<>(e);
        }
        logger.info("新电途平台推送停止充电结果 result:{}", response);
        return response;
    }

    /**
     * 新电途推送充电订单信息
     * http://localhost:8080/xindiantu/pushChargeOrderInfo
     * @param orderCode
     * @return
     */
    @GetMapping("/pushChargeOrderInfo/{orderCode}")
    public RestApiResponse<?> pushChargeOrderInfo(@PathVariable("orderCode") String orderCode) {
        logger.info("新电途平台推送充电订单信息 params:{}", orderCode);
        RestApiResponse<?> response = null;
        try {
            String result = xdtService.pushChargeOrderInfo(orderCode);
            response = new RestApiResponse<>(result);
        }catch (BusinessException e) {
            logger.error("新电途平台推送充电订单信息 error",e);
            response = new RestApiResponse<>(e.getCode(), e.getMessage());
        }catch (Exception e) {
            logger.error("新电途平台推送充电订单信息 error", e);
            response = new RestApiResponse<>(e);
        }
        logger.info("新电途平台推送充电订单信息 result:{}", response);
        return response;
    }

    /**
     * 新电途推送充电状态
     * http://localhost:8080/xindiantu/pushStartChargeResult
     * @param orderCode
     * @return
     */
    @GetMapping("/pushChargeStatus/{orderCode}")
    public RestApiResponse<?> pushChargeStatus(@PathVariable("orderCode") String orderCode) {
        logger.info("新电途平台推送充电状态 params:{}", orderCode);
        RestApiResponse<?> response = null;
        try {
            String result = xdtService.notificationEquipChargeStatus(orderCode);
            response = new RestApiResponse<>(result);
        }catch (BusinessException e) {
            logger.error("新电途平台推送充电状态 error",e);
            response = new RestApiResponse<>(e.getCode(), e.getMessage());
        }catch (Exception e) {
            logger.error("新电途平台推送充电状态 error", e);
            response = new RestApiResponse<>(e);
        }
        logger.info("新电途平台推送充电状态 result:{}", response);
        return response;
    }

    /**
     * 新电途推送启动充电结果
     * http://localhost:8080/xindiantu/pushStartChargeResult
     * @param orderCode
     * @return
     */
    @GetMapping("/pushStartChargeResult/{orderCode}")
    public RestApiResponse<?> pushStartChargeResult(@PathVariable("orderCode") String orderCode) {
        logger.info("新电途平台推送启动充电结果 params:{}", orderCode);
        RestApiResponse<?> response = null;
        try {
            String result = xdtService.notificationStartChargeResult(orderCode);
            response = new RestApiResponse<>(result);
        }catch (BusinessException e) {
            logger.error("新电途平台推送启动充电结果 error",e);
            response = new RestApiResponse<>(e.getCode(), e.getMessage());
        }catch (Exception e) {
            logger.error("新电途平台推送启动充电结果 error", e);
            response = new RestApiResponse<>(e);
        }
        logger.info("新电途平台推送启动充电结果 result:{}", response);
        return response;
    }

    /**
     * 新电途平台设备状态变化推送
     * http://localhost:8080/xindiantu/pushStationStatus
     * @param dto
     * @return
     */
    @PostMapping("/pushStationStatus")
    public RestApiResponse<?> pushStationStatus(@RequestBody PushInfoParamDTO dto) {
        logger.info("新电途平台设备状态变化推送 params:{}", JSON.toJSONString(dto));
        RestApiResponse<?> response = null;
        try {
            if (StringUtils.isBlank(String.valueOf(dto.getPileConnectorCode())) ||
                    StringUtils.isBlank(String.valueOf(dto.getStatus()))) {
                throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
            }
            PushRealTimeInfoDTO pushRealTimeInfoDTO = new PushRealTimeInfoDTO();
            pushRealTimeInfoDTO.setStatus(dto.getStatus());
            pushRealTimeInfoDTO.setPileConnectorCode(dto.getPileConnectorCode());
            pushRealTimeInfoDTO.setThirdPartyType(ThirdPlatformTypeEnum.XIN_DIAN_TU.getTypeCode());
            String result = xdtService.notificationStationStatus(pushRealTimeInfoDTO);
            response = new RestApiResponse<>(result);
        }catch (BusinessException e) {
            logger.error("新电途平台设备状态变化推送 error",e);
            response = new RestApiResponse<>(e.getCode(), e.getMessage());
        }catch (Exception e) {
            logger.error("新电途平台设备状态变化推送 error", e);
            response = new RestApiResponse<>(e);
        }
        logger.info("新电途平台设备状态变化推送 result:{}", response);
        return response;
    }
    
}
